Unit AFH3C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAF10_p;

procedure AFH3C(var A :Array of Complex; N :Integer;
                var IR :Array of Integer; var R :Array of Real;
                var IERR :Integer);

implementation

procedure AFH3C(var A :Array of Complex; N :Integer;
                var IR :Array of Integer; var R :Array of Real;
                var IERR :Integer);
var
N0,N1,I,L,J,LX,IBACK,KK,II,K1,JK,JI,K,II1,K0,KNXJ,IM1,IX,I1,KX,NK,IX1,
   IXI,IDET,I2,JXI,JXI1,J0,JXK,JX,INXJ,LL,IC,IR1,IS_,LX1,INX,IRI,IRJ,
   IRJ1 :Integer;
RN,TEMP,X0,X1,SAVE :Real;
TEMPC,SAVEC,TEMP1,RC :Complex;
const
ALPHA :Real = 0.6403882;
ZERO :Real = 0.0;
ONE :Real = 1.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35;
begin
IERR := 0;
N0 := N-1;
N1 := N+1;
RN := 16.0*(N);
LL := 1;
for I:=1 to N do
 begin
  R[I-1] := ZERO;
  IC := 1;
  L := LL;
  for J:=1 to N do
   begin
    TEMP := Cabs(A[L-1]);
    if ( TEMP > R[I-1] ) 
     then R[I-1] := TEMP;
    if ( J >= I ) 
     then IC := J;
    L := L+IC;
_1:
   end;
  R[I-1] := R[I-1]*RN;
  LL := LL+I;
_2:
 end;
IDET := 1;
I := 1;
L := 0;
_3:
LL := L;
IX := L+I;
IXI := IX+I;
IX1 := IXI+1;
X0 := ZERO;
for J:=I to N do
 begin
  L := L+J;
  X1 := Cabs(A[L-1]);
  if ( X1 <= X0 ) 
   then goto _4;
  X0 := X1;
  K := J;
_4:
 end;
X1 := X0;
IR1 := K;
IS_ := K;
IR[I-1] := K;
I1 := I+1;
if ( I > N0 ) 
 then goto _15;
J := 1;
LX1 := IXI;
for L:=I1 to N do
 begin
  LX := LX1;
  for KK:=1 to J do
   begin
    TEMP := Cabs(A[LX-1]);
    if ( TEMP <= X0 ) 
     then goto _5;
    X0 := TEMP;
    IR1 := L;
    IS_ := KK;
_5:
    LX := LX+1;
_6:
   end;
  LX1 := LX1+L;
  J := J+1;
_7:
 end;
if ( IS_ <> K ) 
 then IS_ := IS_+I-1;
INX := LL;
II := I;
KK := K;
IBACK := 15;
if ( X1 >= X0*ALPHA ) 
 then goto _8;
IBACK := 14;
IR[I-1] := IS_;
KK := IS_;
_8:
if ( KK = II ) 
 then begin
       if ( IBACK=15 ) then goto _15 else
       if ( IBACK=14 ) then goto _14 else
       if ( IBACK=22 ) then goto _22;
      end;
TEMP := R[II-1];
R[II-1] := R[KK-1];
R[KK-1] := TEMP;
K1 := KK+1;
JK := (K1*KK) div 2;
KX := JK-KK;
if ( K1 > N ) 
 then goto _10;
JI := JK+II;
JK := JK+KK;
for J:=K1 to N do
 begin
  TEMPC := A[JK-1];
  A[JK-1] := A[JI-1];
  A[JI-1] := TEMPC;
  JK := JK+J;
  JI := JI+J;
_9:
 end;
_10:
K0 := KK-1;
II1 := II+1;
if ( II1 > K0 ) 
 then goto _12;
JK := KX+II1;
JI := INX+II+II;
for J:=II1 to K0 do
 begin
  TEMPC := A[JI-1];
  A[JI-1] := A[JK-1];
  A[JK-1] := TEMPC;
  JK := JK+1;
  JI := JI+J;
_11:
 end;
_12:
INXJ := INX+II;
KNXJ := KX+KK;
TEMPC := A[INXJ-1];
A[INXJ-1] := A[KNXJ-1];
A[KNXJ-1] := TEMPC;
if ( II = 1 ) 
 then begin
       if ( IBACK=15 ) then goto _15 else
       if ( IBACK=14 ) then goto _14 else
       if ( IBACK=22 ) then goto _22;
      end;
IM1 := II-1;
for J:=1 to IM1 do
 begin
  INXJ := INX+J;
  KNXJ := KX+J;
  TEMPC := A[INXJ-1];
  A[INXJ-1] := A[KNXJ-1];
  A[KNXJ-1] := TEMPC;
_13:
 end;
if ( IBACK=15 ) then goto _15 else
if ( IBACK=14 ) then goto _14 else
if ( IBACK=22 ) then goto _22;
_14:
IR[I1-1] := IR1;
IBACK := 22;
KK := IR1;
II := I1;
INX := INX+I;
goto _8;
_15:
IRI := IR[I-1];
if ( IRI = I ) 
 then goto _18;
IRJ := I1*(I1-1) div 2+I;
IRJ1 := I;
for J:=I1 to IRI do
 begin
  A[IRJ-1] := Conjg(A[IRJ-1]);
  IRJ1 := IRJ1+1;
  IRJ := IRJ+IRJ1;
_16:
 end;
IRJ := IRI*(IRI-1) div 2+I+1;
IRJ1 := IRJ+IRI-I-2;
for J:=IRJ to IRJ1 do
 begin
  A[J-1] := Conjg(A[J-1]);
_17:
 end;
_18:
TEMP := R[I-1]+Cabs(A[IX-1]);
if ( TEMP = R[I-1] ) 
 then goto _34;
if ( I1 > N ) 
 then goto _21;
JX := IX;
L := JX+I;
TEMPC := DivC(Cmplx(ONE,0.0),A[IX-1]);
for J:=I1 to N do
 begin
  INXJ := JX+I;
  SAVEC := A[INXJ-1];
  A[INXJ-1] := MulC(SAVEC,TEMPC);
  KX := L;
  for K:=I1 to J do
   begin
    INXJ := JX+K;
    A[INXJ-1] := SubC(A[INXJ-1],MulC(SAVEC,Conjg(A[KX-1])));
    KX := KX+K;
_19:
   end;
  JX := JX+J;
_20:
 end;
_21:
NK := N+I;
IR[NK-1] := 1;
I := I1;
L := IX;
goto _33;
_22:
IRI := IR[I-1];
if ( IRI = I ) 
 then goto _25;
IRJ := I1*(I1-1) div 2+I;
IRJ1 := I;
for J:=I1 to IRI do
 begin
  A[IRJ-1] := Conjg(A[IRJ-1]);
  IRJ1 := IRJ1+1;
  IRJ := IRJ+IRJ1;
_23:
 end;
IRJ := IRI*(IRI-1) div 2+I+1;
IRJ1 := IRJ+IRI-I-2;
for J:=IRJ to IRJ1 do
 begin
  A[J-1] := Conjg(A[J-1]);
_24:
 end;
_25:
IRI := IR[I+0];
if ( IRI = I1 ) 
 then goto _28;
IRJ := I1*(I1+1) div 2+I1;
IRJ1 := I1;
I2 := I+2;
for J:=I2 to IRI do
 begin
  A[IRJ-1] := Conjg(A[IRJ-1]);
  IRJ1 := IRJ1+1;
  IRJ := IRJ+IRJ1;
_26:
 end;
IRJ := IRI*(IRI-1) div 2+I1+1;
IRJ1 := IRJ+IRI-I1-2;
for J:=IRJ to IRJ1 do
 begin
  A[J-1] := Conjg(A[J-1]);
_27:
 end;
_28:
TEMPC := MulC(A[IX-1],A[IX1-1]);
TEMP := Cabs(TEMPC);
RC := Conjg(A[IXI-1]);
SAVE := TEMP+Cabs(A[IXI-1])*Cabs(RC);
RC := SubC(TEMPC,MulC(A[IXI-1],Conjg(A[IXI-1])));
if ( SAVE = ZERO ) 
 then SAVE := ONE;
SAVE := N*SAVE;
TEMP := SAVE+Cabs(RC);
if ( TEMP = SAVE ) 
 then goto _34;
I2 := I+2;
if ( I2 > N ) 
 then goto _32;
JX := IX+I1;
L := JX;
TEMP1 := DivC(Cmplx(ONE,0.0),RC);
IDET := IDET+1;
J0 := I1;
II := L+I;
for J:=I2 to N do
 begin
  JXI := JX+I;
  JXI1 := JX+I1;
  SAVEC := A[JXI-1];
  TEMPC := A[JXI1-1];
  if ( I2 > J0 ) 
   then goto _30;
  KX := II;
  for K:=I2 to J0 do
   begin
    JXK := JX+K;
    A[JXK-1] := SubC(SubC(Conjg(A[JXK-1]),MulC(A[KX-1],Conjg(SAVEC))),MulC(A[KX+0],
    Conjg(TEMPC)));
    A[JXK-1] := Conjg(A[JXK-1]);
    KX := KX+K;
_29:
   end;
_30:
  A[JXI-1] := MulC((SubC(MulC(A[IX1-1],SAVEC),MulC(A[IXI-1],TEMPC))),TEMP1);
  A[JXI1-1] := MulC((SubC(MulC(A[IX-1],TEMPC),MulC(Conjg(A[IXI-1]),SAVEC))),TEMP1);
  JX := JX+J;
  A[JX-1] := SubC(SubC(A[JX-1],MulC(A[JXI-1],Conjg(SAVEC))),MulC(A[JXI1-1],Conjg(TEMPC)));
  J0 := J;
_31:
 end;
_32:
NK := N+I;
IR[NK-1] := 2;
IR[NK+0] := 0;
L := IX+I1;
I := I2;
_33:
if ( I <= N ) 
 then goto _3;
goto _35;
_34:
IERR := 65;
UTAF10(IERR,31);
_35:
end;

end.
